import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAzurermMaintenanceConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/maintenance_configuration#name DataAzurermMaintenanceConfiguration#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/maintenance_configuration#resource_group_name DataAzurermMaintenanceConfiguration#resource_group_name}
    */
    readonly resourceGroupName: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/maintenance_configuration#timeouts DataAzurermMaintenanceConfiguration#timeouts}
    */
    readonly timeouts?: DataAzurermMaintenanceConfigurationTimeouts;
}
export interface DataAzurermMaintenanceConfigurationWindow {
}
export declare function dataAzurermMaintenanceConfigurationWindowToTerraform(struct?: DataAzurermMaintenanceConfigurationWindow): any;
export declare class DataAzurermMaintenanceConfigurationWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAzurermMaintenanceConfigurationWindow | undefined;
    set internalValue(value: DataAzurermMaintenanceConfigurationWindow | undefined);
    get duration(): string;
    get expirationDateTime(): string;
    get recurEvery(): string;
    get startDateTime(): string;
    get timeZone(): string;
}
export declare class DataAzurermMaintenanceConfigurationWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAzurermMaintenanceConfigurationWindowOutputReference;
}
export interface DataAzurermMaintenanceConfigurationTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/maintenance_configuration#read DataAzurermMaintenanceConfiguration#read}
    */
    readonly read?: string;
}
export declare function dataAzurermMaintenanceConfigurationTimeoutsToTerraform(struct?: DataAzurermMaintenanceConfigurationTimeoutsOutputReference | DataAzurermMaintenanceConfigurationTimeouts | cdktf.IResolvable): any;
export declare class DataAzurermMaintenanceConfigurationTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAzurermMaintenanceConfigurationTimeouts | undefined;
    set internalValue(value: DataAzurermMaintenanceConfigurationTimeouts | undefined);
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/maintenance_configuration azurerm_maintenance_configuration}
*/
export declare class DataAzurermMaintenanceConfiguration extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "azurerm_maintenance_configuration";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/maintenance_configuration azurerm_maintenance_configuration} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAzurermMaintenanceConfigurationConfig
    */
    constructor(scope: Construct, id: string, config: DataAzurermMaintenanceConfigurationConfig);
    get id(): string;
    get location(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    properties(key: string): string | cdktf.IResolvable;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
    get scope(): string;
    tags(key: string): string | cdktf.IResolvable;
    get visibility(): string;
    private _window;
    get window(): DataAzurermMaintenanceConfigurationWindowList;
    private _timeouts;
    get timeouts(): DataAzurermMaintenanceConfigurationTimeoutsOutputReference;
    putTimeouts(value: DataAzurermMaintenanceConfigurationTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): DataAzurermMaintenanceConfigurationTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
